#ifndef SOPT_CPP_CONFIG_H
#define SOPT_CPP_CONFIG_H

//! Problems with using and constructors
#define SOPT_HAS_USING
#ifndef SOPT_HAS_USING
#define SOPT_HAS_NOT_USING
#endif

//! True if using OPENMP
#define SOPT_OPENMP

//! Macro to start logging or not
/* #undef SOPT_DO_LOGGING */

//! Whether or not to include mpi
#define SOPT_MPI

// figures out available basic types
/* #undef SOPT_CHAR_ARCH */
#define SOPT_LONG_ARCH
#define SOPT_ULONG_ARCH


#include <cstdint>
#include <string>
#include <tuple>

namespace sopt {

//! Returns library version
inline std::string version() { return "3.1.0"; }

//! Returns library version
inline std::tuple<uint8_t, uint8_t, uint8_t> version_tuple() {
  return std::tuple<uint8_t, uint8_t, uint8_t>(
      3, 1, 0);
}

//! Returns library git reference, if known
inline std::string gitref() { return "NA"; }

//! Default logging level
inline std::string default_logging_level() { return ""; }

//! Default logger name
inline std::string default_logger_name() { return ""; }

# ifdef SOPT_OPENMP
//! Number of threads used during testing
inline constexpr std::size_t number_of_threads_in_tests() { return 2; }
# endif

} // namespace sopt

#endif
